Version 1.0.24 (18/01/2005)
- Corrected several bugs found by Marcin Garski <mgarski@post.pl>

Version 1.0.23 (13/11/2004)
- Replace GNU LD version script with Libtool -export-symbols-regex,
  from Joe Orton <joe@manyfish.co.uk>.
- Copy libtasn1 has been updated to version 0.2.11.
- Corrected the write of CRL distribution points.
- It is now possible to generate PKCS#12 structures without private
  keys using "certtool --to-p12", suggested by Fabian Fagerholm
  <fabbe@paniq.net>.

Version 1.0.22 (28/10/2004)
- Print DN of certificates with unknown characters in them, but in hexform
  only.
- Corrected bug in _gnutls_x509_get_dn_oid(), and returns the
  actual OID.
- Added second precision to the X.509 parsing functions.
- Add parameter --la-file to libgnutls-config and libgnutls-extra-config,
  tiny patch contributed by Joe Orton <joe@manyfish.co.uk>.
- Add pkg-config meta files, suggested by Stéphane LOEUILLET
  <stephane.loeuillet@tiscali.fr>.
- Fix memory initializaion bug in gnutls_certificate_set_x509_trust,
  tiny patch by Aleix Conchillo Flaque <aleix@member.fsf.org>.
- Fix certtool --password for PKCS #12, back ported from 1.1.x branch.
- Fix library order in libgnutls*-config --libs output, to permit
  static linking, reported by Yoann Vandoorselaere
  <yoann@prelude-ids.org>.

Version 1.0.21 (07/10/2004)
- Fix memory leak in gnutls_certificate_verify_peers and
  gnutls_certificate_free_credentials, report and patch by Simon
  Posnjak <simon.posnjak@cetrtapot.si>.
- Fix crash in `certtool --to-p12 --load-privkey foo', i.e. exporting
  a key and no certificate to PKCS#12.
- Fix objdir != srcdir builds, reported by "Gerrit P. Haase"
  <gp@familiehaase.de>.
- Avoid redefining getpass if system already has it, reported by
  Yoann Vandoorselaere <yoann@prelude-ids.org>.
- Add new example "ex-rfc2818" for certificate verification, from Nikos.
- Known bug: the library require snprintf.

Version 1.0.20 (18/08/2004)
- Bug fix of padding string in RSA PKCS#1 v1.5 type 2 encryption,
  reported by Robey Pointer <robey@danger.com>.

Version 1.0.19 (09/08/2004)
- Bug fix of test suite.

Version 1.0.18 (05/08/2004)
- Added simple self test suite.

Version 1.0.17 (02/08/2004)
- Updated the SRP authentication to conform to the
  latest (yet unreleased) draft. Unfortunately this breaks
  compatibility with previous versions.
- Changed the makefiles to be more portable.
- Added some default limits in the verification of certificate
  chains, to avoid denial of service attacks. Also added 
  gnutls_certificate_set_verify_limits() to override them.
  Issue pointed out by Patrik Hornik <patrik@hornik.sk>.
- Added gnutls_certificate_verify_peers2().

Version 1.0.16 (10/07/2004)
- Do not free the SRP (prime and generator) parameters obtained from the 
  callback if they are the static ones defined in extra.h.
- Eliminated some memory leaks. Reported by Yoann Vandoorselaere.
- Some fixes in the makefiles.

Version 1.0.15 (29/06/2004)
- Fixed bug in RSA encryption, report and patch by Martijn Koster 
  <mak@greenhills.co.uk>.
- Corrected a bug in certificate verification. Pointed out by
  Yoann Vandoorselaere <yoann@prelude-ids.org>.

Version 1.0.14 (12/06/2004)
- Automatically disable certificate types that do not have corresponding
  certificates.
- Updates in the documentation.
- certtool can now add ip address SAN extension.
- certtool has now support for more X.520 DN attribute types.
- Opencdk library is being included if not found.
- Added gnutls_openpgp_keyring_check_id().
- Corrected a serious bug in the included libtasn1 library.
- Corrected session resuming in SRP ciphersuites.
- Updated to conform to the latest srp draft (draft-ietf-tls-srp-07)
- Added the functions gnutls_x509_crt_get_pk_rsa_raw() and
  gnutls_x509_crt_get_pk_dsa_raw() to retrieve parameters from certificates.
- Some fixes in the session resuming code.

Version 1.0.13 (29/04/2004)
- Some complilation fixes.
- Added the --xml parameter to the certtool utility.

Version 1.0.12 (23/04/2004)
- Corrected bug in OpenPGP key loading using a callback.
- Renamed gnutls-srpcrypt to srptool
- Allow handshake requests by the client.
* Things backported from the development branch:
- Added support for authority key identifier and the extended key usage
  X.509 extension fields. The certtoool was updated to support them.
- Added batch support to certtool. Now it can use templates.
- The RC2 cipher is no more included. The one in libgcrypt is now used.

Version 1.0.11 (17/04/2004)
- Added gnutls_sign_algorithm_get_name() and gnutls_pk_algorithm_get_name()
- Corrected bug in TLS renegotiation.

Version 1.0.10 (03/04/2004)
- Corrected bug in RSA parameters handling which could cause
  unexpected crashes.
- Corrected bug in SSL 3.0 authentication.

Version 1.0.9 (29/03/2004)
- Added gnutls_certificate_set_params_function() and 
  gnutls_anon_set_params_function() that set the RSA or DH
  parameters using a callback.
- Added functions gnutls_rsa_params_cpy(), gnutls_dh_params_cpy()
  and gnutls_x509_privkey_cpy().
- Corrected a compilation issue when opencdk was installed in a
  non standard directory.
- Documented the changes need in multi-threaded application due
  to the new libgcrypt.

Version 1.0.8 (28/02/2004)
- Corrected bug in mutual certificate authentication in SSL 3.0.

Version 1.0.7 (25/02/2004)
- Implemented TLS 1.1 (and also obsoleted the TLS 1.0 CBC protection
  hack).
- Some updates in the documentation.

Version 1.0.6 (12/02/2004)
* Backported things from the development branch (while maintaining
  backwards compatibility):
- Improved gnutls-cli's SRP behaviour in SRP ciphersuites.
  If they are of highest priority then the abbreviated handshake
  is used.
- The error codes GNUTLS_E_NO_TEMPORARY_DH_PARAMS and GNUTLS_E_NO_TEMPORARY_RSA_PARAMS
  are no longer returned by the handshake function. Ciphersuites that
  require temporary parameters are removed when such parameters do not exist.
- Added the callbacks gnutls_certificate_client_retrieve_function() and
  gnutls_certificate_server_retrieve_function(), to allow a client or a server
  to specify certificates for the handshake without storing them to the
  credentials structure.
- Added support for generating and exporting DSA private keys.

Version 1.0.5 (11/02/2004)
- Fixed a bug where 'server name' extension was always sent.
* Backported things from the development branch:
- Added CRL verification functionality to certtool.
- Corrected the CRL distribution point extension handling.
- Added PKCS #7 support to certtool utility.
- Added support for reading and generating CRL distribution
  points extensions in certificates.
- Added support for generating CRLs in the library and the
  certtool utility.
- Added support for the Subject Key ID PKIX extension.
- Added the gnutls_sign_algorithm type.

Version 1.0.4 (04/01/2004)
- Changed handshake behaviour to send the lowest TLS version
  when an unsupported version was advertized. The current behaviour
  is to send the maximum version we support.
- certtool no longer asks the password in unencrypted private
  keys.
- The source is now compiled to use the reentrant libc functions.

Version 1.0.3 (21/12/2003)
- Corrected bug in gnutls_bye() which made it return an error code
  of INVALID_REQUEST instead of success.
- Corrected a bug in the GNUTLS_KEY key usage definitions.

Version 1.0.2 (18/12/2003)
- Corrected a bug in the RSA key generation. This was
  generating unusable RSA keys.

Version 1.0.1 (10/12/2003)
- Some minor fixes in the makefiles. They now include CFLAGS
  from libgcrypt or opencdk if installed in a non standard directory.
- Fixed the SRP detection test in gnutls-cli-debug.
- Added gnutls_rsa_params_export_pkcs1() and gnutls_rsa_params_import_pkcs1().

Version 1.0.0 (04/12/2003)
- Exported the static SRP group parameters.
- Some fixes in the certificate authenticated SRP ciphersuites.
- Improved the support for draft-ietf-tls-srp-05. The two-phase
  handshake is now fully supported without any interaction with
  the application layer (except for a callback).

Version 0.9.99 (28/11/2003)
- Some fixes in the gnutls.h header for the gnutls_server_name_set()
  and gnutls_server_name_get() prototypes.
- Exported the gnutls_x509_privkey_sign_data(), gnutls_x509_privkey_verify_data() 
  and gnutls_x509_crt_verify_data().
- Some fixes in the openpgp authentication.
- Removed the Twofish cipher.

Version 0.9.98 (16/11/2003)
- The openssl compatibility layer was moved to gnutls-openssl
  library instead of being included in the gnutls-extra library.
- Added the RIPEMD ciphersuites defined in draft-ietf-tls-openpgp-keys-04.
- Building with openpgp support is now mandatory.
- gnutls4 compatibility header is no longer included by default in
  gnutls.h.
- gnutls8 function usage yelds a deprecation warning in gcc3.
- gnutls_x509_*_set_dn_by_oid() and gnutls_x509_*_get_*_dn_by_oid()
  functions have a raw_flag parameter added.
- Added gnutls_x509_*_get_dn_oid() and gnutls_x509_crt_get_extension_oid()
  functions which return the available OIDs.

Version 0.9.97 (11/11/2003)
- The certtool utility can now generate PKCS #12 structures
  without specifying a certificate.
- Added capability to read CRLs to certtool.
- Corrected some functions which return GNUTLS_E_SHORT_MEMORY_BUFFER
  to properly set the required buffer size.
- Corrected a bug in libgcrypt detection.

Version 0.9.96 (09/11/2003)
- Some changes to allow compilation with mingw32.
- Several code cleanups.

Version 0.9.95 (02/11/2003)
- Improved the verification functions. Added new verification
  output flags and removed the unused and redundant ones.
- Improved the OpenPGP key support.
- The prime utility was removed, and its functionality was moved
  to certtool.

Version 0.9.94 (30/10/2003)
- Added manpages for the included programs.
- Documented and improved the certtool utility. 
- Added PKCS #12 support to certtool utility.

Version 0.9.93 (26/10/2003)
- Corrected some compilation issues.
- Improved the certtool command line utility.

Version 0.9.92 (25/10/2003)
- The RFC2818 hostname verification is now case insensitive.
- Added support for generating X.509 certificates.
- Added the certtool, a tool for generating X.509 certificates

Version 0.9.91 (17/10/2003)
- Fixed a compilation issue in the openpgp authentication part.

Version 0.9.90 (08/10/2003)
- Updated the openpgp key API (depends on the unreleased new
  opencdk).

Version 0.9.8 (02/10/2003)
- Updated the SRP implementation to follow the latest draft
  (draft-ietf-tls-srp-05).
- Improved the gnutls-cli behaviour in error handling,
  and added a check for the peer's hostname.
- Use versioned symbols in the library (where available).
- RIJNDAEL ciphersuites were renamed to AES.

Version 0.9.7 (25/08/2003)
- The tex files are now included in the distribution.
- The library can now decrypt PKCS #12 files encrypted with
  the RC2-40 cipher.
- The missing rfc2818_hostname object is now included.
- Several corrections and bug fixes in the library by 
  Arne Thomassen <arne@arne-thomassen.de>.
- CR is now allowed in the base64 decoder.

Version 0.9.6 (28/06/2003)
- Added gnutls_x509_privkey_get_key_id() and gnutls_x509_crt_get_key_id()
  functions which return a unique (per public key) ID. These can
  be used to check if the private key corresponds to a given certificate.
- Corrections in the TLS layer openpgp certificate packet parser.
- Corrected a bug in the record layer buffering, which affected
  the case where external pull function was used. Report and patch
  by Sergey Poznyakoff <gray@Mirddin.farlep.net>.
- Corrected a bug in gnutls-srpcrypt where a non allocated variable
  was freed.
- SRP programs are now built by default.
- Added API to read and write to PKCS #12 structures. Prototypes
  in gnutls/pkcs12.h.
- The gnutls_transport_ptr type was changed to a pointer type (void*).

Version 0.9.5 (06/04/2003)
- Several improvements in the PKCS #7 handling
- Eliminated several hard coded constants in MPI parameters.

Version 0.9.4 (28/03/2003)
- Corrected a parsing error in the Certificate request message.
- Corrected behaviour when a certificate request message is received.
  Now a certificate packet is always sent, and in SSL 3.0 cipher suites
  a no_certificate alert is sent instead.
- Added functionality to generate PKCS #7 structures (with certificates).

Version 0.9.3 (24/03/2003)
- Support for MD2 was dropped. 
- Improved the error logging functions, by adding a level, and
  by allowing debugging messages just by increasing the level.
- The diffie Hellman ciphersuites are now of higher priority than
  the plain RSA.
- The RSA premaster secret version check can no longer be disabled.
- Implemented the counter measure discussed in the paper "Attacking
  RSA-based Sessions in SSL/TLS", against the attack described in the
  same paper.
- Added the functions: gnutls_handshake_get_last_in(), 
  gnutls_handshake_get_last_out().
- The gnutls_certificate_set_rsa_params() was renamed to 
  gnutls_certificate_set_rsa_export_params().
- Added the new functions: gnutls_certificate_set_x509_key()
  gnutls_certificate_set_x509_trust(), gnutls_certificate_set_x509_crl(),
  gnutls_x509_crt_export(), gnutls_x509_crl_export().
- Added support for encoding and decoding PKCS #8 2.0 encrypted 
  RSA private keys.

Version 0.9.2 (15/03/2003)
- Some corrections in the memory mapping code (file is unmapped after 
  it is read).
- Added support for PKCS#10 certificate requests generation.

Version 0.9.1 (12/03/2003)
- Corrected a bug in 64 bit architectures, which affected the
  serial number calculation in the record layer.
- Added gnutls_certificate_free_keys() which deletes all the
  private keys and certificates from the credentials structure.
- Corrected a broken buffer check in _gnutls_io_read_buffered(),
  which caused some unexpected packet length errors. Report and patch
  by Ian Peters <itp@ximian.com>.
- Added ability to generate RSA keys.
- Increased the maximum parameter size in order to read some large keys
  by some CAs. Patch by Ian Peters <itp@ximian.com>.
- Added an strnstr() function and the requirement in some functions to
  use null terminated PEM structures is no more.
- Use mmap() if available to read files.
- Fixed a memory leak in SRP code reported by Rupert Kittinger 
  <r.kittinger@efkon.com>.

Version 0.9.0 (03/03/2003)
- This version is not binary compatible with the previous ones.
- The library notifies the application on empty and illegal SRP usernames, 
  so that proper notification (via an alert) is sent to the peer.
- Added ability to send some messages back to the application using
  the gnutls_global_set_log_function().
- gnutls_dh_params_generate() and gnutls_rsa_params_generate() now use 
  gnutls_malloc() to allocate the output parameters.
- Added support for MD2 algorithm in certificate signature verification.
- The RSA and DH parameter generation interface was changed. Added
  ability to import and export from and to PKCS3 structures. This 
  was needed to read parameters generated using the openssl dhparam tool.
- Several changes in the temporary (DH/RSA) parameter codebase. No DH 
  parameters are now included in the library. Also the credentials structure 
  can now hold only one temporary parameter of a kind.
- Added a new Certificate, CRL, Private key and PKCS7 structures handling 
  API, defined in gnutls/x509.h
- Added gnutls_certificate_set_verify_flags() function to allow setting the 
  verification flags in the credentials structure. They will be used in the
  *verify_peers functions.
- Added protection against the new TLS 1.0 record layer timing attack.
- Added support for Certificate revocation lists. Functions defined
  in gnutls/x509.h
- The only functions that were removed are:
  gnutls_x509_certificate_to_xml()
  gnutls_x509_extract_dn_string()
- Ported to libtasn1 0.2.x

Version 0.8.1 (22/01/2003)
- Improved the SRP support, to prevent attackers guessing the
  available usernames by brute force.
- Improved the SRP detection in gnutls-cli-debug
- Some fixes which now allow compilation.

Version 0.8.0 (20/01/2003)
- Added gnutls_x509_extract_dn_string() which returns a 
  distinguished name in a single string.
- Added gnutls_openpgp_extract_key_name_string() which returns
  an openpgp user ID in a single string.
- Added gnutls_x509_extract_certificate_ca_status() which returns
  the CA status of the given certificate.
- Added SRP-6 support. Follows draft-ietf-tls-srp-04.
- If libtasn1 is not present in the system, it is included in 
  the main gnutls library.
- If liblzo is present in the system, then the included minilzo
  will not be used, and libgnutls-extra will depend on liblzo.
- GNUTLS_E_PARSING_ERROR error code was replaced by GNUTLS_E_BASE64_DECODING_ERROR, 
  and GNUTLS_E_SRP_PWD_PARSING_ERROR. GNUTLS_E_ASCII_ARMOR_ERROR was also 
  replaced by GNUTLS_E_BASE64_DECODING_ERROR.

Version 0.6.0 (8/12/2002)
- Added "gnutls/compat4.h" header. This is included in gnutls.h
  to emulate the old 0.4.x API.
- Example programs are now stored in doc/examples/
- Several improvements and updates in the documentation.
- Added the certificate authenticated SRP cipher suites.
- gnutls_x509_extract_certificate_dn_string() was updated to return
  an RFC2253 conforming string.
- Added the SRP related functions:
   gnutls_srp_verifier()
   gnutls_srp_base64_encode()
   gnutls_srp_base64_decode()
- Added the function gnutls_srp_set_server_credentials_function()
  to allow retrieving SRP parameters from an external backend - other
  than password files.
- Added the function gnutls_openpgp_set_recv_key_function()
  which can be used to set a callback, to get OpenPGP keys.
- Exported the functions:
   gnutls_malloc()
   gnutls_free()
  which should be used by callback functions.
- Changed the semantics of gnutls_pem_base64_encode_alloc()
  and gnutls_pem_base64_decode_alloc(). In the default case
  were the gnutls library is used with malloc/realloc/free,
  these are binary compatible.

Version 0.5.11 (5/11/2002)
- Some fixes in 'gnutls-cli' client program to prevent some segmentation 
  faults at exit.
- Example programs found in the documentation can now be generated by
  running "make examples" in doc/tex directory.
- Added more descriptive error strings, to gnutls_strerror().
- Documented error codes, and the function reference list is now sorted.
- Optimized buffering code.
- gnutls_x509_extract_certificate_dn_string() was rewritten.
- Added GNUTLS_E_SHORT_MEMORY_BUFFER error code, which is returned in the
  case where the memory buffer provided is not long enough.
- Depends on the new OpenCDK 0.3.2.

Version 0.5.10 (13/10/2002)
- Updated documentation.
- Added server name extension. This allows clients to specify the
  name of the server they connect to. Useful to HTTPS.
- Several corrections in the code base, mostly in signed/unsigned,
  checkings.

Version 0.5.9 (10/10/2002)
- Corrected some code which worked fine in gcc 3.2, but not with any
  other compiler.
- Updated 'gnutls-cli' with the '--starttls' option, to allow testing
  starttls implementations.
- Added gnutls_x509_extract_key_pk_algorithm() function which extracts
  the private key type, of a DER encoded key.
- Added gnutls_x509_extract_certificate_dn_string() which returns the 
  certificate's distinguished name in a single string.
- Added gnutls_set_default_priority() and gnutls_set_default_export_priority()
  functions, to avoid calling all the *_priority() functions if the defaults
  are acceptable.
- Added int gnutls_x509_check_certificates_hostname() which check whether
  the given hostname matches the owner of the given X.509 certificate.

Version 0.5.8 (25/09/2002)
- Updated documentation.
- Added gnutls_record_get_direction() which replaces the obsolete
  gnutls_handshake_get_direction().
- Added function to convert error codes to alert descriptions
- Added LZO compression

Version 0.5.7 (11/09/2002)
- Some fixes in the memory allocation functions (realloc).
- Improved the string functions used in XML certificate generation.
- Removed dependency on libgdbm.
- Corrected bug in gnutls_dh_params_set() which affected
  gnutls_dh_params_deinit().
- Corrected bug in session resuming code in server side.

Version 0.5.6 (6/09/2002)
- Corrected bugs in SRP implementation, which prevented gnutls 
  to interoperate with other implementations. (interoperability testing
  was done by David Taylor)
- Corrected bug in cert_type extension.
- Corrected extension type checks which used an 8 bit extension size,
  instead of 16 bits.
- Added versioning in the XML output of certificate functions.
- Removed the X.509 test suite.

Version 0.5.5 (3/09/2002)
- Updated the SRP implementation to the latest draft. The blowfish
  crypt implementation was removed, since the new draft does not allow
  other hash algorithms except for the srpsha. 
- Renamed all the constructed types in order to have more consistent
  names. 
- Improved the certificate and key read functions. Now they can read 
  the certificate and the private key from the same file.
- Updated and corrected documentation.

Version 0.5.4 (27/08/2002)
- Fixes in TLS 1.0 PRF and SSL3 random functions.
- gnutls_handshake_set_exportable_detection() was obsoleted.
- Added gnutls_openpgp_extract_key_id() which returns the key ID.
- Corrected bug in DHE key exchange
- Added support for temporary RSA keys which are needed for the
  export cipher suites.
- Added the TLS_RSA_EXPORT_ARCFOUR_40_MD5 ciphersuite.

Version 0.5.3 (23/08/2002)
- No changes. Replaces the tarball of 0.5.2 which accidentaly contained
  code from the unstable branch.

Version 0.5.2 (22/08/2002)
- Added an error code that is returned in clients which connect
  to export only servers. This must be enabled using the
  gnutls_handshake_set_exportable_detection() function.
- Updated openssl compatibility layer.
- Added gnutls_handshake_get_direction() function which returns
  the state of the handshake when interrupted.

Version 0.5.1 (17/07/2002)
- Corrected the m4 macros which used <gnutls.h> instead of
  <gnutls/gnutls.h>
- Documentation fixes
- Added gnutls_transport_set_ptr2() function, which accepts two
  different pointers, to be used while receiving, and 
  while sending data.
- Semantic changes in gnutls_record_set_max_size(). The requested
  size is now immediately enforced at the output buffers.
- gnutls_global_init_extra() now fails if the library versions do
  not match.
- Fixes in client and server example programs. Null encryption can
  be used in these programs, to assist in debuging.
- Fixes in zlib compression code.

Version 0.5.0 (6/07/2002)
- Added X.509 certificate tests in tests/ directory
- Removed stubs for SRP and Anonymous authentication. They served
  no purpose since they are always included, unless it was requested
  not to do so.
- Added gnutls_handshake_set_private_extensions() function. This
  function can be used to enable private (gnutls specific) cipher suites
  and compression algorithms.
- Added check for C99 macro support by the compiler.
- Added functions gnutls_b64_encode_fmt2() and gnutls_b64_decode_fmt2()
- Added the new libtasn1 library.
- Removed the gdbm backend. Applications are now responsible for the
  session resuming backend. The gnutls-serv application contains an
  simple example on how to use gdbm for resuming.
- Headers for the gnutls library are now installed in $(includedir)/gnutls
- Added an OpenSSL compatible interface (with some limitations).
- Added functions to convert DER encoded certificates to XML format.

Version 0.4.4 (24/06/2002)
- Corrected bug in PKCS-1 RSA encryption which prevented gnutls to encrypt
  using keys of some specific size.

Version 0.4.3 (23/05/2002)
- The gnutls-extra library now compiles fine, if the opencdk library is
  not present.
- Several bug fixes.
- Added gnutls_global_set_mem_func() function, to set the memory allocation
  functions, if other than the defaults are to be used.
- The default memory allocation functions are now the ones in libc.

Version 0.4.2 (21/05/2002)
- Separated ASN.1 structures parser documentation and TLS library
  documentation.
- Added gnutls_handshake_set_rsa_pms() function, which disables the
  version check in RSA premaster secret.
- Added gnutls_session_is_resumed() function, which reports if a session
  is a resumed one.
- Added gnutls_state_set_ptr() and gnutls_state_get_ptr() functions, to
  assist in callback functions.
- Replaced the included 1024 bit prime for Diffie Hellman, with a new
  random one.
- Relicensed the library under the GNU Lesser General Public License
- Added gnutls-extra library which contains the GPL covered code of gnutls.

Version 0.4.1 (7/04/2002)
- Now uses alloca() for temporary variables
- Optimized RSA signing
- Added functions to return the peer's certificate activation and
  expiration time.
- Corrected time function's behaviour (the time value returned no longer
  relate to local timezone).

Version 0.4.0 (1/04/2002)
- Added support for RFC2630 (PKCS7) X.509 certificate sets
- Added new functions: gnutls_x509_extract_certificate_pk_algorithm(),
  gnutls_openpgp_extract_key_pk_algorithm().
- Several optimizations in the Handshake protocol
- Several optimizations in RSA algorithm
- Unified the return values because of small buffers.

Version 0.3.92 (23/03/2002)
- Updated documentation
- Combined error codes of ASN.1 parser and gnutls
- Removed GNUTLS_CERT_TRUSTED from the CertificateStatus enumeration
- Added protection against CBC chosen plaintext attack (disabled by default)
- Improved and optimized compression support

Version 0.3.91 (3/03/2002)
- Added gnutls-cli-debug program
- Corrections in session resumption
- Rehandshake can now handle negotiation of different authentication
  type.
- gnutls-cli, gnutls-serv, gnutls-srpcrypt and gnutls-cli-debug are 
  now being installed.

Version 0.3.90 (24/02/2002)
- Handshake messages are not kept in memory any more. Now we use 
  less memory during a handshake
- Added support for certificates with DSA parameters
- Added DHE_DSS cipher suites
- Key exchange methods changed so they do not depend on the 
  certificate type. Added certificate type negotiation TLS extension.
- Added openpgp key support (EXPERIMENTAL)
- Improved Diffie Hellman key exchange support.
- Bug fixes in the RSA key exchange.
- Added check for the requested TLS extensions
- TLS extensions now use a 16 bit type field.
- Added a minimal string library to assist in ASN.1 parsing
- Changes in ASN.1 parser to work with the new bison
- Added gnutls_x509_extract_subject_alt_name(), which deprecates 
  gnutls_x509_extract_subject_dns_name()
- gnutls_x509_set_trust_(file/mem) can now be called multiple times
- gnutls_srp_server_set_cred_file() can now be called multiple times

Version 0.3.5 (25/01/2002)
- Corrected the RSA key exchange method, to avoid attacks against
  PKCS-1 formating.

Version 0.3.4 (20/01/2002)
- Corrected bugs in DHE_RSA key exchange method

Version 0.3.3 (19/01/2002)
- Added gnutls_x509pki_verify_certificate()
- Added gnutls_x509pki_set_trust_mem() and gnutls_x509pki_set_key_mem()
- Bug fixes in srpcrypt (based on patch by Marc Huber)
- Bug fixes in the Handshake protocol (based on patch by Guillaume Morin)
- Corrected library versioning

Version 0.3.2 (5/01/2002)
- Corrected bug which did not allow a client to accept multiple CA names
- Added gnutls_fingerprint()
- Added gnutls_x509pki_extract_certificate_serial()
- Added gnutls_b64_encode_fmt() and gnutls_b64_decode_fmt()
- Corrected behaviour in version advertizing
- Updated documentation
- Prefixed all types in gnutls.h with 'GNUTLS_' to avoid namespace collisions

Version 0.3.1 (21/12/2001)
- Corrections in the configuration files
- Fixes a bug in anonymous authentication

Version 0.3.0 (17/12/2001)
- Corrected bug in new integer formatting (now we use the old format again)
- Several corrections and usual cleanups

Version 0.2.91 (10/12/2001)
- Fixes in MPI handling (fixes possible bug with signed integers)
- Removed name indication extension
- Added gnutls_transport_get_ptr() and gnutls_db_get_ptr()
- Optimizations in server certificate callback.
- Fixes in anonymous authentication
- Corrections in client ciphersuite selection

Version 0.2.90 (7/12/2001)
- gnutls_handshake(), gnutls_read() etc. functions no longer require
  the 'SOCKET cd' argument. This argument is set using the function
  gnutls_set_transport_ptr().
- introduced gnutls_x509pki_get_peer_certificate_list(). This function returns
  a list containing peer's certificate and issuers DER encoded.
- Updated X.509 certificate handling API
- Added callback to select the server certificate
- More consistent function naming (changes in several function names)
- Buffer overflow checking in ASN.1 structures parser
- Updated documentation

Version 0.2.11 (16/11/2001)
- Changed the meaning of GNUTLS_E_REHANDSHAKE value. If this value
  is returned, then the caller should perform a handshake or send
  an alert to the peer.
- Made receive buffer dynamic. Normaly if no large chunks are received
  it occupies less space.
- Added max_record_size extension
- Bugfixes in session handling
- Improved non blocking IO support in the Handshake Protocol
- Usual bugfixes and cleanups
- Documentation updated (includes ASN.1 documentation)

Version 0.2.10 (5/11/2001)
- Corrected bugs and improved non blocking IO
- Added hooks to use external database to store sessions
- Usual cleanups

Version 0.2.9 (27/10/2001)
- AUTH_INFO types and structures were moved to library internals
- AUTH_FAILED is no longer returned in SRP authentication
  (any fatal error in SRP means auth failed)
- Introduced GNUTLS_E_INTERRUPTED
- Added support for non blocking IO
- gnutls_recv() and gnutls_send() are now obsolete
- Changed semantics of gnutls_rehandshake()

Version 0.2.4 (12/10/2001)
- Better handling of X.509 certificate extensions
- Added DHE_RSA ciphersuites
- Updated the Name Indication (dnsname) extension
- Improvements in Diffie Hellman primes handling

Version 0.2.3 (19/09/2001)
- Memory optimizations in gnutls_recv()
- Fixed several memory leaks
- Added ability to specify callback for x509 client certificate selection
- Better documentation

Version 0.2.2 (21/08/2001)
- Several bugfixes (library and documentation)

Version 0.2.1 (07/08/2001)
- SRP fixes

Version 0.2.0 (07/08/2001)
- Partial support for X.509v3 Certificate extensions.
- Added Internal memory handlers
- Removed gnutls_x509_set_cn()
- Added X.509 client authentication
- Several bug fixes and protocol fixes

Version 0.1.9 (30/07/2001)
- Corrected bug(s) in ChangeCipherSpec packet (fixes renegotiate)
- SRP is updated to conform to the newest draft.
- Added support for DNSNAME extension.
- Reentracy fixes in ASN.1 Parsing.
- Optimizations in hash/hmac functions
- (Error) message handling has changed
- Better Protocol Version handling
- Added X.509 Certificate Verification
- gnutls_read() semantics are now closer to read(2) - added EOF
- Documented some part of gnutls in doc/tex/ using Latex

Version 0.1.4 (22/06/2001)
- Corrected (srp) base64 encoding.
- Changed bcrypt algorithm to include username.
- Added RSA Ciphersuites (no certificate checking).
- Fixes in SSL 2.0 client hello parsing.
- Added ASN.1 and DER parsers.
- Bugfixes in session resuming
- Updated Ciphersuite selection algorithm
- Added internal representation of X.509 structures.
- Added global state

Version 0.1.3 (01/06/2001)
- Updated API (and the way it is documented - we use inline documentation)
- Added function to access alert messages.
- Added support for renegotiating parameters.
- Better and Faster Resume Database handling.
- Several bugfixes

Version 0.1.2 (14/05/2001)
- Updated API
- Fixes in extension handling

Version 0.1.1 (13/05/2001)
- Added compatibility with Stanford's libsrp library

Version 0.1.0 (09/05/2001)
- Added SSL 2.0 client hello support
- GNUTLS is a gnu library
- Added support for TLS extensions.
- Added support for SRP

Version 0.0.7 (11/01/2001)
- Added server side session resuming (using gdbm)
- Added twofish algorithm

Version 0.0.6 (20/12/2000)
- Added client side session resuming
- Better documentation (check doc/API)
- Better socket handling (gnutls can be used with select())
- Some primitive support for non blocking IO and socket options has been added.

Version 0.0.5 (7/12/2000)
- Added Compression (using ZLIB)
- Added SSL 3.0 support
